#ifndef HEADER_H
#define HEADER_H

#include <sys/types.h>
#include <arpa/inet.h>

/* Portions of this code is from the wireshark source */

struct val_80211 
{
	uint32_t did;
	uint16_t status, len;
	uint32_t data;
};

struct prism_hdr 
{
	uint32_t msgcode, msglen;
	char devname[16];
	struct val_80211 hosttime, mactime, channel, rssi, sq, signal,
									 noise, rate, istx, frmlen;
};

struct llc_hdr
{
	u_char dsap;
	u_char ssap;
	u_char control;
	u_char oui[3];
	u_char type[2];
};

typedef u_char address[6];

struct wlan_hdr 
{
	uint16_t fc;
	uint16_t dur;
	address addr1;
	address addr2;
	address addr3;
	uint16_t seq;
	uint16_t qos;
};

struct ip_hdr
{
	u_char version_hdrlen;
	u_char dsfield;
	uint16_t len;
	uint16_t id;
	u_char flags;
	u_char frag_offset;
	u_char ttl;
	u_char proto;
	uint16_t checksum;
	u_char src[4];
	u_char dst[4];
};

struct udp_hdr
{
	uint16_t srcport;
	uint16_t dstport;
	uint16_t len;
	uint16_t checksum;
};

struct radiotap_hdr {
	uint8_t        it_version;     /* set to 0 */
	uint8_t        it_pad;
	uint16_t       it_len;         /* entire length */
	uint32_t       it_present;     /* fields present */
} __attribute__((__packed__));


static inline int wlan_seqnum(uint16_t seq)
{
	//seq = ntohs(seq);
	return seq >> 4;
}

static inline int wlan_retry(uint16_t fc)
{
	u_char* fcb = (u_char*)&fc;
	return (fcb[1] & 0x08) > 0;
}
#endif
